/* --------------------------------------- */
/* By Andy Carvell - andy@burningimage.net */
/* --------------------------------------- */

#include <stdio.h>
#include "radio.h"

#define HOME 7
#define STATUS 8
#define DISARM 25
#define HOUSE 11

int main(int argc, char **argv)
{

	setup_io();

	INP_GPIO(HOME);
	INP_GPIO(STATUS);
	INP_GPIO(DISARM);
	INP_GPIO(HOUSE);

	OUT_GPIO(HOME);
	OUT_GPIO(STATUS);
	OUT_GPIO(DISARM);
	OUT_GPIO(HOUSE);

	if (argc == 2)
	{
		if (!strcmp(argv[1],"home"))
		{
			GPIO_SET = 1 << HOME;
			usleep(3000000);
			GPIO_CLR = 1 << HOME;
		}
		else if (!strcmp(argv[1],"status"))
		{
			GPIO_SET = 1 << STATUS;
			usleep(3000000);
			GPIO_CLR = 1 << STATUS;
		}
		else if (!strcmp(argv[1],"disarm"))
		{
			GPIO_SET = 1 << DISARM;
			usleep(3000000);
			GPIO_CLR = 1 << DISARM;
		}
		else if (!strcmp(argv[1],"house"))
		{
			GPIO_SET = 1 << HOUSE;
			usleep(3000000);
			GPIO_CLR = 1 << HOUSE;
		}
		else
		{
			printf("Invalid input\n");
		}
	}
	else
	{
		printf("Invalid input\n");
	}
}

