/* --------------------------------------- */
/* By Andy Carvell - andy@burningimage.net */
/* --------------------------------------- */

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "radio.h"

void main(void)
{
	unsigned int count, temp, length;
	int i;
	time_t cur_time;
	char* nice_time;
	char sc[11] = {0}; //Needs to be able to hold any value of int

	cur_time = time(NULL);
	nice_time = ctime(&cur_time);
	// Remove the silly newline from the end of the string
	nice_time[strlen(nice_time) - 1] = 0;

	setup_io();

	// Set GPIO14 as an output (have to set as input first)
	INP_GPIO(14);
	OUT_GPIO(14);

	GPIO_CLR = 1<<14;

	//Wait 10ms just to make sure it's discharged
	usleep(10000);

	INP_GPIO(14);

	count = 0;

	//Reset the nice string
	for (i=0; i<strlen(sc); i++)
	{
		sc[i] = 0;
	}

	// Take 10 readings
	for (i=0; i<10; i++)
	{
		OUT_GPIO(14);
		GPIO_CLR = 1<<14;
		usleep(10000);
		INP_GPIO(14);

		while ((!(GPIO_GET & (1<<14))) && (count < 200000000))
		{
			count++;
		}

		//printf("%d\n",count);

		if (count == 200000000)	
		{
			break;
		}

	}

	if (i == 10)
	{
		count /= 10;
		//printf("Light level: %d (%s)\n", count, nice_time);
		//Convert to string and print nicely
		sprintf(sc, "%d", count);
		length = strlen(sc);
		printf("Light level: ",length);
		if (length == 9) printf("%c%c%c,%c%c%c,%c%c%c",sc[0],sc[1],sc[2],sc[3],sc[4],sc[5],sc[6],sc[7],sc[8]);
		else if (length == 8) printf("%c%c,%c%c%c,%c%c%c",sc[0],sc[1],sc[2],sc[3],sc[4],sc[5],sc[6],sc[7]);
		else if (length == 7) printf("%c,%c%c%c,%c%c%c",sc[0],sc[1],sc[2],sc[3],sc[4],sc[5],sc[6]);
		else if (length == 6) printf("%c%c%c,%c%c%c",sc[0],sc[1],sc[2],sc[3],sc[4],sc[5]);
		else if (length == 5) printf("%c%c,%c%c%c",sc[0],sc[1],sc[2],sc[3],sc[4]);
		else if (length == 4) printf("%c,%c%c%c",sc[0],sc[1],sc[2],sc[3]);
		else if (length == 3) printf("%c%c%c",sc[0],sc[1],sc[2]);
		else if (length == 2) printf("%c%c",sc[0],sc[1]);
		else if (length == 1) printf("%c",sc[0]);
		else printf("Can't display value");
		printf(" (%s)\n", nice_time);

	}
	else
	{
		printf("Light level: >200,000,000 (%s)\n", nice_time);
	}

	OUT_GPIO(14);
	GPIO_CLR = 1<<14;

}
