/* --------------------------------------- */
/* By Andy Carvell - andy@burningimage.net */
/* --------------------------------------- */

//Geoff Johnson's code (http://www.hoagieshouse.com/RaspberryPi/RCSockets/RCPlug.html) used as a base.

#include <string.h>
#include <sys/time.h>
#include <stdio.h>

#include "radio.h"
#include "microchiptx.h"

void enabletx(void);
void disabletx(void);
void SendCode(char* szCode);

int main(int argc, char **argv)
{
	static const char devicecode[] = "10001000111010001110111010001000100010001000100011101110111011101000111011101000";

	static const char on[] = "1110";
	static const char off[] = "1000";

	static const char channel1[] = "1110111011101";
//	static const char channel1[] = "1000111010001";

	static const char channel2[] = "1000111011101";
	static const char channel3[] = "1110100011101";
	static const char channel4[] = "1110111010001";

	static const char amble[] = "0000";

	//Set up the GPIO port to transmit
	setup_io();

	// Enable transmitter
	enabletx();

	// Don't use the PLL
	//setup_fm(1);
	//ACCESS(CM_GP0DIV) = (0x5a << 24) + 0x374F; //tune to 144.64MHz

	//Start with a nice fresh array
	char tosend[500] = {0};

	//Initialise the tosend array
	strcpy(tosend, amble);
	strcat(tosend, devicecode);

	if (argc == 3)
	{
		if (!strcmp(argv[2],"on"))
		{
			strcat(tosend, on);
		}
		else if (!strcmp(argv[2],"off"))
		{
			strcat(tosend, off);
		}

		if (!strcmp(argv[1],"1"))
		{
			strcat(tosend, channel1);
		}
		else if (!strcmp(argv[1],"2"))
		{
			strcat(tosend, channel2);
		}
		else if (!strcmp(argv[1],"3"))
		{
			strcat(tosend, channel3);
		}
		else if (!strcmp(argv[1],"4"))
		{
			strcat(tosend, channel4);
		}

		//Add the post-amble
		strcat(tosend, amble);

		if (strlen(tosend) != (strlen(amble) + strlen(devicecode) + strlen(channel1) + strlen(on) + strlen(amble)))
		{
			printf("Invalid parameters\n");
		}
		else
		{
			SendCode(tosend);
		}
	}
	else
	{
		printf("Usage: <channel> <on/off>\n");
	}

	// Turn off the PLL
	//ACCESS(CM_GP0DIV) = (0x5a << 24);
	//setup_fm(0);

	// Disable transmitter
	disabletx();
}

void SendCode(char* szCode)
{
	int i, j;

	for (i=0; i < 10; i++)
	{

		for (j=0; j<strlen(szCode); j++)
		{
			if (szCode[j] == '1')
			{
				//askHigh();
				askon();
			}
			else
			{
				//askLow();
				askoff();
			}
			usleep(222);
		}
		usleep(10000);
	}
}

