<?php
////////////////////////////////////////////////////////////////////////////////
//
// COMMON PAGE
//
//   Defines require_authentication() function:
//     If the user is not authenticated, forward to the login page
//
//////////////////////////////////////////////////////////////////////////////// 

// We only need this for the attempt log function
require("logwrite.php");

session_start();

function is_authenticated()
{

	if (isset($_SESSION['authenticated']) && ($_SESSION['authenticated'] == "yes"))
	{
		return 1;
	}
	else
	{
		// See if the special cookie is set.  If it is then bypass authentication
		if (isset($_COOKIE['chelters']) && file_exists("users/".$_COOKIE['chelters']))
		{
			// get the username out of the file
			$handle = fopen("users/".$_COOKIE['chelters'],'r');
			$_SESSION['username'] = fread($handle,filesize("users/".$_COOKIE['chelters'])); 
			fclose($handle);
			$_SESSION['authenticated'] = "yes";
			attemptlog("Successful cookie authentication using username ".$_SESSION['username']);
			return 1;
		}
		else
		{
			return 0;
		}

	}
}

function require_authentication($page)
{
	if (!is_authenticated())
	{
		header("Location:login.php?page=".$page."&error=".urlencode("Not authenticated"));
		exit;
	}
}
?>
